/*
	SVEditFile.h
	
	Version 3.0d7
	
	Copyright  Apple Computer UK Ltd. 1992
	
	All rights reserved.
	
	Produced by : UK Developer Technical Support
	AppleLink   : UK.DTS
*/

/*
										 
	Known problems-:
		
	System 7.0 specifics-:
		Saving a file using a temporary filename generated using a random file name.
		Note the use of PBExchangeFiles to make sure that the FileIDs of the new file is the
		same as the old one.
*/
/*
	Changes for 3.0d2 :
		19-Feb-92	: NH : Fix open of doc with no other docs open and has
		                 published sections.
	  18-Mar-92	:	NH : AssocAllSections called after SaveAs
		27-Mar-92	: NH : Arrow Cursor on alerts
                     Comment file some more
	  28-Mar-92 : NH : GetFileNameToSaveAs - return FALSE if cancelled (was TRUE!)
		
	Changes for 3.0d4 :
	
		14-Jul-92 : NH : GetFileNameToSaveAs and others return errors when fail
		
	Changes for 3.0d5 :
	
		10-Aug-92 : NH : Save Options for Quit added
		
*/

#ifndef __SVEDITFILE__
#define __SVEDITFILE__

#include <Memory.h>
#include <QuickDraw.h>
#include <Traps.h>
#include <Files.h>
#include <Packages.h>
#include <Editions.h>
#include <AppleEvents.h>
#include <Printing.h>

#include "SVEditGlobals.h"
#include "SVEditUtils.h"
#include "SVEditWindow.h"
#include "SVEditions.h"
				 
pascal void DoQuit(DescType saveOpt);

pascal OSErr DoClose(WindowPtr aWindow,Boolean canInteract,DescType dialogAnswer);

pascal OSErr GetFileNameToSaveAs(DPtr theDocument);

pascal OSErr DoSave(DPtr theDocument, FSSpec theFSSpec);

pascal OSErr GetFileContents(FSSpec theFSSpec, DPtr theDocument);

pascal void FileError(Str255 s, Str255 f);

pascal OSErr SaveUsingTemp(DPtr theDocument);

pascal OSErr OpenOld(FSSpec aFSSpec);

pascal OSErr OpenUsingAlias(AliasHandle theAliasH);

pascal OSErr GetFile(FSSpec *theFSSpec);

#endif