/*
	MSEditions.h
	
	Version 1.0d4
	
	Copyright  Apple Computer UK Ltd. 1992
	
	All rights reserved.
	
	Produced by : UK Developer Technical Support
	AppleLink   : UK.DTS
*/

#ifndef __MSEDITIONS__
#define __MSEDITIONS__

#include <Types.h>
#include <QuickDraw.h>
#include <Files.h>
#include <Packages.h>
#include <GestaltEqu.h>
#include <Editions.h>
#include <Printing.h>

#include "MSGlobals.h" 
#include "MSUtils.h"

pascal void AddSection(SectHandle newSection, DPtr aDocument);

pascal void CreateSection(SectionHandle   EMSection,
												  short           sectionID,
												  short           theStart,
												  short           theEnd,
												  DPtr            aDocument,
												  RgnHandle       theBorder);

pascal void DeleteASection(SectHandle sectToDelete, DPtr theDoc);

pascal void AssocAllSections(DPtr theDoc);

/*routines for writing out and reading in section resources*/
/*rAliasType and rSectionType resources*/

pascal void ReadAllSectionResources(DPtr  aDoc);

pascal void ReadSectionRecords(DPtr  aDoc);

pascal void ReadASection(SectHandle  aSectHandle);

pascal void SaveASection(SectHandle aSection, short count);

pascal void SaveSections(DPtr aDocument);

/*routines for writing out editions*/

pascal void ReadAnEdition(SectionHandle mySectHdl);

pascal void WriteAllEditions(DPtr aDocument);

pascal void WriteAnEdition(SectionHandle mySectHdl);

/*routines for handling the section borders*/

pascal SectHandle GetSection(short theStartPos, short theEndPos, DPtr aDoc);

pascal void RecalcBorders(DPtr aDoc, Boolean invalidate);

pascal void SetSelectionRgn(TEHandle  theTEHandle,
                            short     posStart,
														short     posEnd,
														RgnHandle	*theSelRgn);

pascal void ShowSectionBorders(DPtr aDoc);
		
pascal void DoTEPasteSectionRecalc(DPtr theDoc);
		
pascal void DoTEDeleteSectionRecalc(DPtr theDoc);
		
pascal void DoTECutSectionRecalc(DPtr theDoc);

pascal void DoTEKeySectionRecalc(DPtr theDoc, char theChar);
		
/*utility routines*/

pascal SectHandle GetERefCon(SectionHandle EMSection);

pascal void SetERefCon(SectionHandle  EMSection, SectHandle aSectHandle);

pascal void DeRegisterAllSections(DPtr aDoc);

pascal Handle GetHandleToText(TEHandle aTEHandle, short theStart, short theEnd);

/*now the routines for dealing with the user interface issues*/

pascal void DoSectionOptions(DPtr theDoc);

pascal void DoSubscribe(DPtr theDoc);

pascal OSErr GetEditionContainer(DPtr theDoc, FSSpec *theFSSpec);

pascal OSErr PublishText(DPtr theDoc, FSSpec *theFSSpec);
		
pascal Boolean KeyOKinSubscriber(char whatKey);

pascal Boolean OKToModifySelection(DPtr theDocument);

pascal void RecalcChangedSectionBorders(DPtr theDocument);

#endif